--- sysdeps/freebsd/prockernel.c.orig	2004-07-18 22:33:56.000000000 +0200
+++ sysdeps/freebsd/prockernel.c	2005-01-14 10:27:49.000000000 +0100
@@ -122,13 +122,19 @@
 
 #define	PROC_WCHAN	ki_wchan
 #define	PROC_WMESG	ki_wmesg
-#define	PROC_WMESG	ki_wmesg
+#define	PROC_WEMESG	ki_wmesg
+
+#elif defined(__DragonFly__)
+
+#define PROC_WCHAN      kp_thread.td_wchan
+#define PROC_WMESG      kp_thread.td_wmesg
+#define PROC_WEMESG     kp_eproc.e_wmesg
 
 #else
 
 #define	PROC_WCHAN	kp_proc.p_wchan
 #define	PROC_WMESG	kp_proc.p_wmesg
-#define	PROC_WMESG	kp_eproc.e_wmesg
+#define	PROC_WEMESG	p_eproc.e_wmesg
 
 #endif
 
@@ -138,7 +144,7 @@
 	buf->flags |= (1L << GLIBTOP_PROC_KERNEL_NWCHAN);
 
 	if (pinfo [0].PROC_WCHAN && pinfo [0].PROC_WMESG) {
-		g_strlcpy (buf->wchan, pinfo [0].PROC_WMESG,
+		g_strlcpy (buf->wchan, pinfo [0].PROC_WEMESG,
 			 sizeof buf->wchan);
 		buf->flags |= (1L << GLIBTOP_PROC_KERNEL_WCHAN);
 	} else {
