--- sysdeps/freebsd/procsignal.c.orig	2005-01-14 09:07:01.000000000 +0100
+++ sysdeps/freebsd/procsignal.c	2005-01-14 10:09:42.000000000 +0100
@@ -69,7 +69,14 @@
 		return;
 	}
 
-#if defined(__FreeBSD__) && (__FreeBSD_version >= 500013)
+#if defined(__DragonFly__)
+
+#define PROC_SIGLIST    kp_proc.p_siglist
+#define PROC_SIGMASK    kp_proc.p_sigmask
+#define PROC_SIGIGNORE  kp_eproc.e_procsig.ps_sigignore
+#define PROC_SIGCATCH   kp_eproc.e_procsig.ps_sigcatch
+
+#elif defined(__FreeBSD__) && (__FreeBSD_version >= 500013)
 
 #define	PROC_SIGLIST	ki_siglist
 #define	PROC_SIGMASK	ki_sigmask
