--- sysdeps/freebsd/procuid.c.orig	2004-06-09 20:52:21.000000000 +0200
+++ sysdeps/freebsd/procuid.c	2005-01-10 09:41:28.000000000 +0100
@@ -93,6 +93,18 @@
 #endif
 #else
 
+#if defined(__DragonFly__)
+#define PROC_RUID       kp_eproc.e_ucred.cr_ruid
+#define PROC_SVUID      kp_eproc.e_ucred.cr_svuid
+#define PROC_RGID       kp_eproc.e_ucred.cr_rgid
+#define PROC_SVGID      kp_eproc.e_ucred.cr_svgid
+#define PROC_PPID       kp_eproc.e_ppid
+#define PROC_PGID       kp_eproc.e_pgid
+#define PROC_TPGID      kp_eproc.e_tpgid
+#define PROC_NICE       kp_proc.p_nice
+#define PROC_PRIORITY   kp_proc.p_priority
+#else
+
 #define	PROC_RUID	kp_eproc.e_pcred.p_ruid
 #define	PROC_SVUID	kp_eproc.e_pcred.p_svuid
 #define	PROC_RGID	kp_eproc.e_pcred.p_rgid
@@ -104,6 +116,7 @@
 #define	PROC_PRIORITY	kp_proc.p_priority
 
 #endif
+#endif
 
 	buf->uid  = pinfo [0].PROC_RUID;
 	buf->euid = pinfo [0].PROC_SVUID;
