--- sysdeps/freebsd/proclist.c.orig	2004-07-18 22:33:56.000000000 +0200
+++ sysdeps/freebsd/proclist.c	2005-01-13 13:38:50.000000000 +0100
@@ -91,11 +91,18 @@
 #define PROC_PID	ki_pid
 
 #else
+#if defined(__DragonFly__)
+#define PROC_STAT	kp_proc.p_stat
+#define PROC_RUID	kp_eproc.e_ucred.cr_ruid
+#define PROC_PID	kp_proc.p_pid
+
+#else
 #define PROC_STAT	kp_proc.p_stat
 #define PROC_RUID	kp_eproc.e_pcred.p_ruid
 #define PROC_PID	kp_proc.p_pid
 
 #endif
+#endif
 
 		if ((real_which & GLIBTOP_EXCLUDE_IDLE) &&
 		    (pinfo[i].PROC_STAT != SRUN))
@@ -103,6 +110,11 @@
 		else if ((real_which & GLIBTOP_EXCLUDE_SYSTEM) &&
 			 (pinfo[i].PROC_RUID == 0))
 			continue;
+#if defined(__DragonFly__)
+		if (pinfo[i].PROC_PID < 0) {
+			pinfo[i].PROC_PID = 0;
+		}
+#endif
 		pids [j++] = (unsigned) pinfo[i].PROC_PID;
 	} /* end for */
 	/* Set the fields in buf */
