--- sysdeps/freebsd/procstate.c.orig	2004-08-22 21:29:05.000000000 +0200
+++ sysdeps/freebsd/procstate.c	2005-01-10 09:41:28.000000000 +0100
@@ -81,6 +81,15 @@
 #define PROC_STAT	ki_stat
 
 #else
+#if defined(__DragonFly__)
+#define PROC_COMM       kp_thread.td_comm
+#define PROC_SVUID      kp_eproc.e_ucred.cr_svuid
+#define PROC_SVGID      kp_eproc.e_ucred.cr_svgid
+#define PROC_RUID       kp_eproc.e_ucred.cr_ruid
+#define PROC_RGID       kp_eproc.e_ucred.cr_rgid
+#define PROC_STAT       kp_proc.p_stat
+
+#else
 #define	PROC_COMM	kp_proc.p_comm
 #define	PROC_SVUID	kp_eproc.e_pcred.p_svuid
 #define	PROC_SVGID	kp_eproc.e_pcred.p_svgid
@@ -89,6 +98,7 @@
 #define	PROC_STAT	kp_proc.p_stat
 
 #endif
+#endif
 
 	g_strlcpy (buf->cmd, pinfo [0].PROC_COMM, sizeof buf->cmd);
 
